前言

用户觉得异常是不好的,认为出现异常是写的人的问题。

这是不全面,错误的出现并不总是编写程序的人的原因,有时会因为应用程序的最终用户引发的动作或运行代码的环境而发生错误,比如你用android4去安装现在的微信,或者说我们写的android程序不需要兼容android4,需要的效果就是在android4上安装然后崩溃。

我们编写代码的人需要做的是预测程序中出现的错误,并进行相应的处理,甚至有时候我们应该主动抛出异常。

无论编写的代码技术多么强,程序都必须处理可能发生的错误,比如说做客户端的时候,突然网络中断了,那么后续操作需要中断,我们需要做相应的处理;又比如说我们的文件出现权限问题,那么我们又需要处理。

这里介绍一下为什么我们调用io方法,如果是去读取一个不存在的文件为什么抛出的是异常,而不是返回一个空的对象。

因为判断是这样子的,先把代码贴出来:

string filePath = Environment.CurrentDirectory + "/content.txt";
Stream source = new FileStream(filePath, FileMode.Open, FileAccess.Read);

如果filePath 不存在那么将会抛出异常。

之所以抛出异常是这样子的,FileStream是要去创建一个文件流,按理说文件流创建不成功,那么我的目的没有达到那么就应该返回异常,异常就是我并没有达到我使用的目的。

那么为啥我们调用indexof可以返回-1,表示我们没有找到呢?是因为返回-1是约定,如果有约定那么可以不用抛出异常。

那么我们是否可以约定new FileStream返回为空呢?是不能的,因为存在歧义。文件流创建不成功,到底是文件不存在呢?还是权限问题呢?这些都是需要告诉我们的。

总结一下为什么我们需要主动抛出异常:

1.调用的目的没有达到就应该抛出异常。

2.如果有约定就可以按照约定,如果约定存在歧义,那么不能使用约定。

好吧,那么开始正文吧。

正文

异常处理功能使用 try、catch 和 finally 关键字来尝试执行可能失败的操作、在你确定合理的情况下处理故障,以及在事后清除资源。

在try、catch、finally中,catch块的运行方式值得关注:

如果引发异常的语句不在 try 块内或者包含该语句的 try 块没有匹配的 catch 块,

则运行时将检查调用方法中是否有 try 语句和 catch 块。 运行时将继续调用堆栈,搜索兼容的 catch 块。 

在找到并执行 catch 块之后,控制权将传递给 catch 块之后的下一个语句。

举个例子:

static void Main(string[] args)
{
FileStream sw = null;
try
{
sw = new FileStream(@"C:\test\test.txt", FileMode.Open, FileAccess.ReadWrite)
sw.Write(new byte[1]);
}
catch (DirectoryNotFoundException ex)
{
//文件目录没有找到异常
Console.WriteLine(ex);
}
catch (FileNotFoundException ex)
{
//文件没有找到异常
Console.WriteLine(ex);
}
catch (IOException ex)
{
//io操作异常
Console.WriteLine(ex);
}
finally
{
sw?.Flush();
sw?.Close();
}
}

没有找到找到相应的catch,那么会一步一步往下找。

首先是查看DirectoryNotFoundException ,然后是FileNotFoundException,只要是io操作出现问题都会是IOException。

那么我该如何知道DirectoryNotFoundException、FileNotFoundException、IOException他们的关系呢?

这时候就需要看图了,图不大,可以记下来。

如图:

上面这些是常用的,可以说是必会的吧,下面介绍一下他们的作用。

异常 详细
ArgumentException 方法参数异常
ArgumentNullException 参数为空异常
ArgumentOutOfRangeException 索引小于零或超出数组边界时,尝试对数组编制索引时引发
ArithmeticException 算术运算期间出现的异常的基类,例如 DivideByZeroException 和 OverflowException。
OverflowException 当在检查的上下文中执行的算术、强制转换或转换运算导致溢出时引发的异常
StackOverflowException 执行堆栈由于有过多挂起的方法调用而用尽时引发;通常表示非常深的递归或无限递归。
IOException 发生I/O错误时引发的异常。
FileLoadException 找到托管程序集但不能加载时引发的异常
FileNotFoundException 文件没有找到
EndOfSteamExcetion 读操作试图超出流的末尾时引发的异常。
DriveNotFoundException 当尝试访问的驱动器或共享不可用时引发的异常。
ApplicationException 用作应用程序定义的异常的基类
TargetInvocationException 由通过反射调用的方法引发的异常
CompositionException 表示在 CompositionContainer 对象中进行组合期间发生一个或多个错误时引发的异常。
ChangeRejectedException 一个指示部件在组合期间是否已遭拒绝的异常。

有些异常是我们写代码不应该去产生异常的,比如说ApplicationException作为基类的异常,如果出现这些异常一般是我们代码写的有问题,

而不是我们的主观因素。应从 Exception 类(而不是 ApplicationException 类)派生自定义异常。 不应在代码中引发 ApplicationException 异常,除非你

打算重新引发原始异常,否则不应捕获 ApplicationException 异常。 这里举个例子:TargetInvocationException的基类是ApplicationException,这个是

由通过反射调用的方法引发的异常。如果产生这个问题,可以想象是我们反射使用的有问题。同样如果我们去写反射的程序,我们不应该去catch这个,而是让他直接

报错,表示代码就不应该这么写,出错然后去解决。

好吧,回到原问题上,假如没有找到兼容性的catch块那么会怎么样呢?

那么实验一下吧。

实验如下:

会抛出异常的,所以我们写代码的时候需要确保最后一个一定能捕获到异常的,如果sw.Write(new byte[1]);出现错误那么非托管资源就没有释放。

那么如何万一我们没有捕获到异常也能是否非托管资源呢?使用using。

static void Main(string[] args)
{
try
{
using (var sw = new FileStream(@"C:\test\test.txt", FileMode.Open, FileAccess.ReadWrite))
{
sw.Write(new byte[1]);
}
}
catch (DirectoryNotFoundException ex)
{
//文件目录没有找到异常
Console.WriteLine(ex);
}
finally
{
}
}

这样写无论是否异常,那么都会释放非托管资源。这个是可以实验的,我把我的实验贴一下。

上面的说明已经被关闭了,我们再次关闭的时候将会产生异常。这个using可以看下IL,就清楚其中的原理。

异常过滤器

异常过滤器是c#的东西,这里只是做简单的介绍,后面异常代码优化章节中会重点介绍。

public static bool ConsoleLogException(Exception e)
{
var oldColor = Console.ForegroundColor;
Console.ForegroundColor = ConsoleColor.Red;
Console.WriteLine("Error:{0}",e);
Console.ForegroundColor = oldColor;
return false;
}
static void Main(string[] args)
{
int i = 10;
try
{
throw new TimeoutException("time out");
}
catch (Exception e) when(ConsoleLogException(e))
{ }
catch (TimeoutException e) when (i == 10)
{ }
finally
{
Console.ReadKey();
}
}

输出结果:



上面说明一个问题,无论catch是否匹配,when都会执行。

同样来做一个实验,判断when 如果不匹配也就是没有catch块执行那么会怎么样?

static void Main(string[] args)
{
int i = 10;
try
{
throw new TimeoutException("time out");
}
catch (Exception e) when(ConsoleLogException(e))
{ }
catch (TimeoutException e) when (i == 9)
{
Console.WriteLine("enter timeoutexception");
}
finally
{
Console.ReadKey();
}
}

结果:

重新抛出异常

为什么要重新抛出异常呢?

static int GetValueFromArray(int[] array, int index)
{
try
{
return array[index];
}
catch (System.IndexOutOfRangeException ex)
{
System.ArgumentException argEx = new System.ArgumentException("Index is out of range", "index", ex);
throw argEx;
}
}

本来是要抛出IndexOutOfRangeException 改为了ArgumentException 这是为什么呢?

原因如下:用户要调用的是我们的方法GetValueFromArray,传入的是参数,方法没有越界这么一说,而不是一个数组,所以我们要争对我们的目的来确定我们抛出的异常。

用户自定义异常

自定义异常水比较深,在此只做一个简单的介绍,单独一节补齐。

class CostumExcetion:Exception
{
public CostumExcetion(string message) : base(message)
{ }
}

调用如下:

static void Main(string[] args)
{
int i = 10;
try
{
throw new CostumExcetion("自定义异常");
}
catch (Exception e) when(ConsoleLogException(e))
{ }
catch (CostumExcetion e) when (i == 10)
{
Console.WriteLine(e.Message);
}
finally
{
Console.ReadKey();
}
}

调用者信息

现在又一个需要,知道try中出现错误,但是我需要知道是那一会出现错误,这个怎么破呢?

也就是说我们希望定位到行级,那么我们就需要调用者信息了。

在异常中,我们又很多方法调用一个方法,然后在这个方法中出现问题,我们需要知道是怎么报错的,到底是哪个函数调用报错的,这时候我们需要使用查询到调用者信息。

举个例子:

public class CallerInformationHelper
{
public void Log([CallerLineNumber]int line = -1, [CallerFilePath] string path = null, [CallerMemberName]string name = null)
{
Console.WriteLine((line<0)?"no line":"Line"+line);
Console.WriteLine((path==null)?"No file path":path);
Console.WriteLine((name==null)?"No Member name":name);
Console.WriteLine();
}
}

调用:

 CallerInformationHelper helper = new CallerInformationHelper();
helper.Log();

结果:

因为异常整理较多,所以后续还有两节整理。

1.异常注意事项,本章续。

2.解析盛派框架如何自定义异常类(以前做小程序的时候看过源码)。

以上只是个人理解,如有问题请指出。如果学习,看文档最佳。

重学c#系列——异常(六)的更多相关文章

  1. .net基础学java系列(六)Java基础

    一.废话 .net学java为何一直没入坑?其实大家都知道,语法很相似,就是使用的习惯不同 稍微的语法差异 结构体系不同 IDE不同 类库集不同 各种框架不同 对于我来说,我一直被第三道坎拦住了,所以 ...

  2. 重学计算机组成原理(六)- 函数调用怎么突然Stack Overflow了!

    用Google搜异常信息,肯定都访问过Stack Overflow网站 全球最大的程序员问答网站,名字来自于一个常见的报错,就是栈溢出(stack overflow) 从函数调用开始,在计算机指令层面 ...

  3. 重学Golang系列(一): 深入理解 interface和reflect

    前言 interface(即接口),是Go语言中一个重要的概念和知识点,而功能强大的reflect正是基于interface.本文即是对Go语言中的interface和reflect基础概念和用法的一 ...

  4. 重学数据结构系列之——平衡树之SB Tree(Size Blanced Tree)

    学习来源:计蒜客 平衡树 1.定义 对于每一个结点.左右两个子树的高度差的绝对值不超过1,或者叫深度差不超过1 为什么会出现这样一种树呢? 假如我们依照1-n的顺序插入到二叉排序树中,那么二叉排序树就 ...

  5. 重学前端 --- Promise里的代码为什么比setTimeout先执行?

    首先通过一段代码进入讨论的主题 var r = new Promise(function(resolve, reject){ console.log("a"); resolve() ...

  6. 重学js之JavaScript 面向对象的程序设计(创建对象)

    注意: 本文章为 <重学js之JavaScript高级程序设计>系列第五章[JavaScript引用类型]. 关于<重学js之JavaScript高级程序设计>是重新回顾js基 ...

  7. 打算写一个《重学Node.js》系列,希望大家多多支持

    先放上链接吧,项目已经开始2周了:https://github.com/hellozhangran/happy-egg-server 想法 现在是2019年11月24日,还有人要开始学习Node.js ...

  8. C#微信公众号开发系列教程六(被动回复与上传下载多媒体文件)

    微信公众号开发系列教程一(调试环境部署) 微信公众号开发系列教程一(调试环境部署续:vs远程调试) C#微信公众号开发系列教程二(新手接入指南) C#微信公众号开发系列教程三(消息体签名及加解密) C ...

  9. Redis总结(五)缓存雪崩和缓存穿透等问题 Web API系列(三)统一异常处理 C#总结(一)AutoResetEvent的使用介绍(用AutoResetEvent实现同步) C#总结(二)事件Event 介绍总结 C#总结(三)DataGridView增加全选列 Web API系列(二)接口安全和参数校验 RabbitMQ学习系列(六): RabbitMQ 高可用集群

    Redis总结(五)缓存雪崩和缓存穿透等问题   前面讲过一些redis 缓存的使用和数据持久化.感兴趣的朋友可以看看之前的文章,http://www.cnblogs.com/zhangweizhon ...

  10. Java集合类简单总结(重学)

    java集合类简介(重学) 一.Collection(集合).Map接口两者应该是平行关系吧. 1.Map介绍 Map是以键值(key-value)对来存放的,2个值.通过key来找到value(例: ...

随机推荐

  1. java 深入技术五 (泛型)

    1.泛型概述 泛型的本质:参数化类型 定义 Object obj=new Object();//并不是所有类都可以使用泛型 List <String> list=new ArrayList ...

  2. window10系统安装SQL数据库和小蝴蝶的问题

    最近刚刚升了windows10系统.由于以前一直使用的是SQL2008数据库,所以也就没有下载最新的数据库,但是在安装的过程中一直提示让重启,重启了很多回也没有用. 在启动SQL2008安装程序的时候 ...

  3. ios 录音

    http://code4app.com/ios/%E5%BD%95%E9%9F%B3%E5%92%8C%E6%92%AD%E6%94%BE/51ba821b6803fa6901000000

  4. Codeforces Round #323 (Div. 2) C. GCD Table 暴力

    C. GCD Table Time Limit: 1 Sec Memory Limit: 256 MB 题目连接 http://codeforces.com/contest/583/problem/C ...

  5. requestAnimationFrame 兼容处理

    (function() { ; var vendors = ['ms', 'moz', 'webkit', 'o']; ; x < vendors.length && !wind ...

  6. 百度apistore第三方登陆使用说明

    最近做一个个人博客,其中的登陆模块我想使用第三方登陆来做.上网搜一下有好多例子,但是大多数都是一个网站的第三方登陆,如QQ.微博.人人,没有集成的组件,于是就在网上搜一下百度的apistore,百度果 ...

  7. 由.Net类库提供的农历计算

             由.Net类库提供的农历计算(C#农历)                 2007-11-21 12:47:00 标签:.Net 类库 农历计算 C#农历 休闲            ...

  8. angular学习第一天——安装batarang踩到的那些坑儿

      angularjs作为一个新兴的JavaScript框架,因其具有不少新特性,比如mvc开发模块,双向数据绑定等等,使其名声大噪.我也久闻其大名,然而因为时间问题,一直都没有去接触过他.这几天工作 ...

  9. 腾讯云的云数据库MYSQL配置

    腾讯云的云数据库MYSQL配置

  10. POJ 2513 字典树+并查集+欧拉路径

    Description: 给定一些木棒,木棒两端都涂上颜色,求是否能将木棒首尾相接,连成一条直线,要求不同木棒相接的一边必须是相同颜色的. 解题思路: 可以用图论中欧拉路的知识来解这道题,首先可以把木 ...